/***
 *  $Id$
 **
 *  File: HdfsMerger.java
 *  Created: Nov 30, 2011
 *
 *  Author: Jaroslaw Zola <jaroslaw.zola@gmail.com>
 *
 *  This file is part of CLOSET.
 *
 *  Copyright (c) 2011-2012 Xiao Yang, Jaroslaw Zola, Srinivas Aluru
 *
 *  Permission is hereby granted, free of charge, to any person
 *  obtaining a copy of this software and associated documentation
 *  files (the "Software"), to deal in the Software without
 *  restriction, including without limitation the rights to use,
 *  copy, modify, merge, publish, distribute, sublicense, and/or sell
 *  copies of the Software, and to permit persons to whom the
 *  Software is furnished to do so, subject to the following
 *  conditions:
 *
 *  The above copyright notice and this permission notice shall be
 *  included in all copies or substantial portions of the Software.
 *
 *  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 *  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 *  OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 *  NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 *  HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 *  WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 *  FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 *  OTHER DEALINGS IN THE SOFTWARE.
 */

import java.io.IOException;

import org.apache.hadoop.conf.Configuration;
import org.apache.hadoop.fs.FileSystem;
import org.apache.hadoop.fs.FileUtil;
import org.apache.hadoop.fs.Path;

public class HdfsMerger {
    public static void main(String[] args) throws IOException {
	String cf = "";
	String in = "";
	String out = "";

	if (args.length == 2) {
	    in = args[0];
	    out = args[1];
	} else if (args.length == 3) {
	    cf = args[0];
	    in = args[1];
	    out = args[2];
	} else return;

	Configuration conf = new Configuration(true);
	if (args.length == 3) conf.addResource(new Path(cf));

	FileSystem fs = FileSystem.get(conf);
	FileUtil fu = new FileUtil();

	Path src = new Path(in);
	Path dst = new Path(out);
	Path ndst = new Path(in + "/" + out);

	fu.copyMerge(fs, src, fs, dst, true, conf, new String(""));
	fu.copy(fs, dst, fs, ndst, true, conf);
    } // main
} // HdfsMerger
