/***
 *  $Id$
 **
 *  File: disjoint_set.hpp
 *  Created: Oct 04, 2010
 *
 *  Author: Jaroslaw Zola <jaroslaw.zola@gmail.com>
 *  Copyright (c) 2010 Jaroslaw Zola
 *  Distributed under the Boost Software License.
 *  See accompanying LICENSE.
 *
 *  This file is part of jaz.
 */

#ifndef JAZ_DISJOINT_SET_HPP
#define JAZ_DISJOINT_SET_HPP

namespace jaz {

  template <typename Int> inline void set_make(Int* uf, Int n) {
      for (Int i = 0; i < n; ++i) uf[i] = i;
  } // set_make

  template <typename Int> inline Int set_find(Int x, Int* uf) {
      if (uf[x] != uf[uf[x]]) uf[x] = set_find(uf[x], uf);
      return uf[x];
  } // set_find

  template <typename Int> inline void set_union(Int x, Int y, Int* uf) {
      Int xx = set_find(x, uf);
      Int yy = set_find(y, uf);
      if (xx != yy ) { if (xx < yy) uf[yy] = xx; else uf[xx] = yy; }
  } // set_union

} // namespace jaz

#endif // JAZ_DISJOINT_SET_HPP
